{{
        Wooden keyboard. Second attempt after loss of initial version


}}
CON

        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000

        M1pin = 19
        M2pin = 20
        M3pin = 21                                      'The three Microphone inputs
        BkLt = -1                                       'Backlight pin
        LcdEn = 18
        RdWr = 17
        RS = 16
        D4 = 8                                          'LCD comms

OBJ

  lcd :         "jm_lcd4_ez RAB"
  'pst :         "Parallax Serial Terminal"
  
VAR

long    Stack1[10]
long    Stack2[10]
long    Stack3[10]
long    M1, M2, M3
long    C1, C2, C3

PUB Start

'pst.Start(9600)                   
lcd.initx(BkLt, LcdEn, RdWr, RS, D4, 16, 2)   
lcd.initx(BkLt, LcdEn, RdWr, RS, D4, 16, 2)
'TestLcd
'TestInputs
SpinRead
'AssyRead
 
PUB SpinRead  

cognew(CapStrike(M1pin,@C1),@Stack1)
cognew(CapStrike(M2pin,@C2),@Stack2)
cognew(CapStrike(M3pin,@C3),@Stack3)
GetDisp

PUB AssyRead
 
M1 := |< M1pin                  
cognew(@entry,@M1)              
M2 := |< M2pin                  
cognew(@entry,@M2)
M3 := |< M3pin                  
cognew(@entry,@M3)
GetDisp
 
PUB GetDisp

repeat
  waitpne(%1110000000000000000000,%1110000000000000000000,0) 'Confirm a strike 
  waitcnt(cnt + 400000)                                      'Wait for readings 
  M1 := C1
  M2 := C2
  M3 := C3  
                                                     'Freeze the readings, dealing
  if M1 < M2 and M1 < M3                                     'with the LCD can take a long time. 
    M2 := M2 - M1
    M3 := M3 - M1
    M1 := 0
  if M2 < M1 and M2 < M3                                     'Find lowest reading and subtract
    M1 := M1 - M2                                            'it from the others, then make it zero
    M3 := M3 - M2
    M2 := 0
  if M3 < M1 and M3 < M2              
    M1 := M1 - M3
    M2 := M2 - M3
    M3 := 0
  if M1 < 60000 and M2 < 60000 and M3 < 60000               'Sane values? then display them.
    lcd.moveto(1, 1)
    lcd.str(String("a        "))
    lcd.moveto(2, 1)
    lcd.dec(M1)  
    lcd.moveto(8, 1) 
    lcd.str(String("b        ")) 
    lcd.moveto(9, 1) 
    lcd.dec(M2)          
    lcd.moveto(1, 2) 
    lcd.str(String("c            ")) 
    lcd.moveto(2, 2) 
    lcd.dec(M3)

PUB TestLcd

repeat
  LCD.scrollstr(1, 1, 16, 200, string("                It Works!   "))
  waitcnt(cnt + 160000000)

PUB TestInputs  |idx

lcd.str(string("In TestInputs"))
repeat
  'waitpne(|<21,|<21,0)
  waitpne(%1110000000000000000000,%1110000000000000000000,0)
  lcd.moveto(1, 2)
  lcd.str(String("Strike "))
  lcd.dec(idx++)

PUB CapStrike(pin,retvar)|time  'Capture the time of a strike

Repeat
  waitpne(|<pin,|<pin,0)        'Wait for strike
  time := cnt                   'Capture system counter
  long[retvar] := time
  waitcnt(cnt + 8000000)        'Wait for board to stop ringing

DAT

''        ***********************************     
''        *  Assembly version of CapStrike  *               
''        ***********************************
''                                                                                 
                        org

entry                   rdlong  ppin, par       'retrieve pin mask
                        nop                     'Clear the pipeline
                        '************************Deterministic timing in each iteration begins**
loop                    waitpne ppin, ppin      'Wait for a knock..(Pin will go low..)
                        mov     spad, cnt       'Cache time locally to avoid HUB access jitter
                        '************************End of deterministic timing********************
                        wrlong  spad, par       'Write time to shared memory
                        add     spad, ring      'Set up 1/10 second ringing delay
                        waitcnt spad, #0        'Wait 1/10 second
                        jmp     loop            'loop forever.
                   
ring                    long    8000000         '1/10 of a second's worth of clock
spad                    res   1                 'Scratchpad
ppin                    res   1                 'Parameter pin mask        
       